import * as tslib_1 from "tslib";
import * as React from 'react';
import { autobind, BaseComponent, createRef } from '../../Utilities';
import { ComboBox } from './ComboBox';
import { List } from '../../List';
var VirtualizedComboBox = /** @class */ (function (_super) {
    tslib_1.__extends(VirtualizedComboBox, _super);
    function VirtualizedComboBox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        /** The combo box element */
        _this._comboBox = createRef();
        /** The virtualized list element */
        _this._list = createRef();
        return _this;
    }
    VirtualizedComboBox.prototype.dismissMenu = function () {
        if (this._comboBox.value) {
            return this._comboBox.value.dismissMenu();
        }
    };
    VirtualizedComboBox.prototype.focus = function () {
        if (this._comboBox.value) {
            this._comboBox.value.focus();
            return true;
        }
        return false;
    };
    VirtualizedComboBox.prototype.render = function () {
        return (React.createElement(ComboBox, tslib_1.__assign({}, this.props, { componentRef: this._comboBox, onRenderList: this._onRenderList, onScrollToItem: this._onScrollToItem })));
    };
    VirtualizedComboBox.prototype._onRenderList = function (props) {
        var onRenderItem = props.onRenderItem;
        // Render virtualized list
        return (React.createElement(List, { componentRef: this._list, role: 'listbox', items: props.options, onRenderCell: onRenderItem ? function (item) { return onRenderItem(item); } : function () { return null; } }));
    };
    VirtualizedComboBox.prototype._onScrollToItem = function (itemIndex) {
        // We are using the List component, call scrollToIndex
        this._list.value && this._list.value.scrollToIndex(itemIndex);
    };
    tslib_1.__decorate([
        autobind
    ], VirtualizedComboBox.prototype, "_onRenderList", null);
    tslib_1.__decorate([
        autobind
    ], VirtualizedComboBox.prototype, "_onScrollToItem", null);
    return VirtualizedComboBox;
}(BaseComponent));
export { VirtualizedComboBox };
//# sourceMappingURL=VirtualizedComboBox.js.map